defdbl a-z
const FALSE= (0=1)
const TRUE = (1=1)
CONST PI = 3.141592653589#
def fnMargin(x)=x*1.000001
const Video = TRUE

Init:
  print "CHAIN generator for PVRAY 1.0  by K. Koehler  v1.0"
  print
  ' 08-10-92 KJK New program (@ Inlaws between houses)

  input "Link Inside Diameter :",LinkID
  input "Metal Radius         :",MetalRadius
  input "Number of Links      :",Links
  LinkUnit=1
  LinkHieght=LinkUnit/2 + MetalRadius
  LinkWidth =LinkID + MetalRadius
  LoopOrigin=LinkHieght - LinkWidth
  a9 = -2 * (LinkWidth ^ 2 + MetalRadius ^ 2)	' torus stuff
  a25 = 2 * (LinkWidth ^ 2 - MetalRadius ^ 2)	' torus stuff
  a34 = (LinkWidth ^ 2 - MetalRadius ^ 2) ^ 2	' torus stuff
  MaxX=LinkWidth + MetalRadius
  MaxY=LinkHieght + MetalRadius
  MaxZ=MetalRadius
  MaxXYZ=MaxX
  if MaxY > MaxXYZ then MaxXYZ=MaxY
  if MaxZ > MaxXYZ then MaxXYZ=MaxZ
  if Video then screen 1 : color 7
  wy=MaxXYZ*1.1 			  ' allow % extra screen space
  wx=wy*1.5				  ' adjust aspect ratio
  if Video then window (-wx,-wy) - (wx,wy)

BuildExample:
  open "chain.pov" for output as #1
  gosub DatTop
  gosub DatBottom
  close #1

BuildObject:
  open "chain.inc" for output as #1
  print #1,"
  print #1,"#declare ChainTex0  = texture { Shiny  colour Red  }
  print #1,"#declare ChainTex1  = texture { Shiny  colour Blue }
  print #1,"
  PRINT #1, "#declare Torus ="
  PRINT #1, "   quartic {"
  PRINT #1, "      <1.0 0.0 0.0 0.0 2.0 0.0 0.0 2.0 0.0 "
  PRINT #1, "      "; a9; " 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0"
  PRINT #1, "       0.0 0.0 1.0 0.0 0.0 2.0 0.0 "; a25; " 0.0"
  PRINT #1, "       0.0 0.0 0.0 1.0 0.0 "; a9; "0.0"; a34; ">"
  PRINT #1, "    } // end_quartic"
  print #1,"
  print #1,	 "#declare Link =
  print #1,	 "  object {
  print #1,	 "  union {
  print #1,	 "       // LinkID =";LinkID ;" MetalRadius =";MetalRadius ;" Links =";Links
  print #1,	 "    intersection {
  print #1,using "      box { <###.#### ###.#### ###.####> ";-(LinkWidth+MetalRadius);-LoopOrigin;-MetalRadius ;
  print #1,using "<###.#### ###.#### ###.####> }";-(LinkWidth-MetalRadius); LoopOrigin; MetalRadius
  print #1,	 "      quadric { Cylinder_Y ";
  print #1,using "scale <###.#### 1 ###.####>  ";MetalRadius;MetalRadius;
  print #1,using "translate <###.#### 0 0> }";-LinkWidth
  print #1,	 "    }
  if Video then
    line (-(LinkWidth+MetalRadius),-LoopOrigin) - (-(LinkWidth+MetalRadius), LoopOrigin),4
    line (-(LinkWidth-MetalRadius),-LoopOrigin) - (-(LinkWidth-MetalRadius), LoopOrigin),1
  endif
  print #1,	 "    intersection {
  print #1,using "      box { <###.#### ###.#### ###.####> "; (LinkWidth-MetalRadius);-LoopOrigin;-MetalRadius ;
  print #1,using "<###.#### ###.#### ###.####> }"; (LinkWidth+MetalRadius); LoopOrigin; MetalRadius
  print #1,	 "      quadric { Cylinder_Y ";
  print #1,using "scale <###.#### 1 ###.####>  ";MetalRadius;MetalRadius;
  print #1,using "translate <###.#### 0 0> }"; LinkWidth
  print #1,	 "    }
  if Video then
    line ( (LinkWidth-MetalRadius),-LoopOrigin) - ( (LinkWidth-MetalRadius), LoopOrigin),1
    line ( (LinkWidth+MetalRadius),-LoopOrigin) - ( (LinkWidth+MetalRadius), LoopOrigin),4
  endif
  print #1,	 "    intersection {
  print #1,	 "      plane { <0 -1 0> 0 }
  print #1,	 "      quartic { Torus rotate <90 0 0> }"
  print #1,using "      translate <0 ###.#### 0>"; LoopOrigin
  print #1,	 "    }
  if Video then
    circle (0, LoopOrigin), LinkWidth+MetalRadius, 4, 0, PI
    circle (0, LoopOrigin), LinkWidth-MetalRadius, 1, 0, PI
  endif
  print #1,	 "    intersection {
  print #1,	 "      plane { <0  1 0> 0 }
  print #1,	 "      quartic { Torus rotate <90 0 0> }"
  print #1,using "      translate <0 ###.#### 0>";-LoopOrigin
  print #1,	 "    }
  if Video then
    circle (0,-LoopOrigin), LinkWidth+MetalRadius, 4, PI, 2*PI
    circle (0,-LoopOrigin), LinkWidth-MetalRadius, 1, PI, 2*PI
  endif
  print #1,	  "  } // end_union
  print #1,	  "  texture { ChainTex0 }
  print #1,	  "  bounded_by {
  print #1,using  "    box { <###.#### ###.#### ###.####> ";-MaxX;-MaxY;-MaxZ;
  print #1,using	    "<###.#### ###.#### ###.####> } "; MaxX; MaxY; MaxZ
  print #1,	  "    } // end_bound"
  print #1,	  "  } // end_object
  if Links > 1 then gosub BuildChain
  close #1
  if Video then while inkey$="":wend
end

BuildChain:
  toggle%=FALSE
  Range=(LinkUnit*(Links-1)/2)
  print #1,
  print #1,	 "#declare Chain =
  print #1,	 "  composite {
  print #1,	 "       // Center of link at chain ends = <0 +/-";Range;" 0>"
  for k = -Range to Range step LinkUnit
    print #1,using "    object { Link  translate <0 #####.#### 0>  ";k;
    if toggle% then
      print #1,"rotate <0 90 0>  ";
    else
      print #1,"texture { ChainTex1 } ";
    endif
    toggle% = not toggle%
    print #1,"}"
  next k
  print #1,	  "    bounded_by {
  print #1,using  "      box { <###.#### ###.#### ###.####> ";-MaxX;-MaxY-Range;-MaxX;
  print #1,using	    "<###.#### ###.#### ###.####> } "; MaxX; MaxY+Range; MaxX
  print #1,	  "    } // end_bound"
  print #1,	 "  } // end_composite
  return

DspFile:
  print #1,"
  print #1,"camera {
  print #1,"   location  <0.0 0.0 ";-1.2*LinkUnit*Links;">"
  print #1,"   direction <0.0 0.0 1.0>
  print #1,"   up  <0.0  1.0  0.0>
  print #1,"   right <1.33333 0.0 0.0>
  print #1,"   look_at <0.0 0.0 0.0>"
  print #1,"}
  print #1,"
  print #1,"/* put down the beloved famous raytrace green/yellow checkered floor */
  print #1,"object {
  print #1,"   plane { <0.0 1.0 0.0>";-(LinkUnit*(Links+1)/2);"}"
  print #1,"   texture {
  print #1,"      checker colour Yellow colour Green
  print #1,"      scale <";MaxXYZ/3*Links;" ";MaxXYZ/3*Links;" ";maxXYZ/3*Links;">"
  print #1,"      ambient 0.3
  print #1,"      diffuse 0.7
  print #1,"   }
  print #1,"}
  print #1,"
  if Links=1 then
    print #1,"object {
    print #1,"    Link
    print #1,"}
  else
    print #1,"composite {
    print #1,"    Chain  rotate <0 30 0>
    print #1,"}
  endif
  print #1,"
  print #1,"object { light_source { ";
  print #1,"<";10*MaxXYZ;" ";12*MaxXYZ;" ";-13*MaxXYZ;">";
  print #1," colour White } }"
return

DatTop:
  print #1,"// Persistence of Vision Raytracer
  print #1,"#include ";chr$(34);"shapes.inc";chr$(34)
  print #1,"#include ";chr$(34);"colors.inc";chr$(34)
  print #1,"#include ";chr$(34);"textures.inc";chr$(34)
  print #1,"
  print #1,"//----------------------- Definitions start here -----------------------
return

DatBottom:
  print #1,"
  print #1,"#include ";chr$(34);"chain.inc";chr$(34)
  print #1,"
  print #1,"//----------------------- Display starts here --------------------------
  print #1,"
  gosub DspFile
return
